## molmodel 3.1.0

=== CMakeLists.txt ===
#---------------------------------------------------
# Molmodel
#
# Creates SimTK library, base name=SimTKmolmodel.
# Default libraries are shared & optimized. Variants
# are created for static (_static) and debug (_d) and
# provision is made for an optional "namespace" (ns)
# and version number (vn).
#
# Windows:
#   [ns_]SimTKmolmodel[_d].dll
#   [ns_]SimTKmolmodel[_d].lib
#   [ns_]SimTKmolmodel_static[_d].lib
# Unix:
#   lib[ns_]SimTKmolmodel[_d].so
#   lib[ns_]SimTKmolmodel_static[_d].a
#
# All libraries are installed in
#   %ProgramFiles%\SimTK\lib    (Windows)
#   /usr/local/SimTK/lib[64]    (Linux, Mac)
#
# Also creates an OpenMM plugin DLL that is used at
# runtime to determine whether OpenMM is available.
# That DLL is named
#   OpenMMPlugin[_d].dll
#   libOpenMMPlugin[_d].so
#   libOpenMMPlugin[_d].dylib
# And there is no static version.
#----------------------------------------------------

CMAKE_MINIMUM_REQUIRED(VERSION 3.10)

PROJECT(Molmodel)

SET(MOLMODEL_MAJOR_VERSION 3)
SET(MOLMODEL_MINOR_VERSION 1)
SET(MOLMODEL_PATCH_VERSION 0)

SET(MOLMODEL_COPYRIGHT_YEARS "2006-12")

# underbar separated list of dotted authors, no spaces or commas
set(MOLMODEL_AUTHORS "Christopher.Bruns_Michael.Sherman")
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(ASSUME_VERSIONED_SIMBODY "Assume that Simbody libraries were built with the version tag appended to the libraries name" OFF)

# Report the version number to the CMake UI. Don't include the
# build version if it is zero.
SET(PATCH_VERSION_STRING)
IF(MOLMODEL_PATCH_VERSION)
    SET(PATCH_VERSION_STRING ".${MOLMODEL_PATCH_VERSION}")
ENDIF()

set(
    MOLMODEL_VERSION
    "${MOLMODEL_MAJOR_VERSION}.${MOLMODEL_MINOR_VERSION}${MOLMODEL_PATCH_VERSION}"
)

set(
    MOLMODEL_SONAME_VERSION
    "${MOLMODEL_MAJOR_VERSION}.${MOLMODEL_MINOR_VERSION}"
)

# Permit use of custom FindOpenMM and FindSimbody modules
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake_modules")

# Find Simbody using the local FindSimbody.cmake if present.
find_package(Simbody REQUIRED)
find_package(OpenMM REQUIRED)
find_package(ZLIB REQUIRED)

include_directories(SYSTEM ${Simbody_INCLUDE_DIR})
include_directories(SYSTEM ${OpenMM_INCLUDE_DIR})
include_directories(SYSTEM ${ZLIB_INCLUDE_DIRS})

# Make everything go in the same binary directory. (These are CMake-defined
# variables.)
SET(EXECUTABLE_OUTPUT_PATH ${BUILD_BINARY_DIR})
SET(LIBRARY_OUTPUT_PATH ${BUILD_BINARY_DIR})

SET(BUILD_SHARED_LIBRARIES TRUE CACHE BOOL
    "Build dynamically linked (shared) version of the libraries")

# Static libraries, tests, and examples won't be built unless this
# is SET.
SET(BUILD_STATIC_LIBRARIES FALSE CACHE BOOL
    "Build '_static' versions of the libraries libraries?")
IF((NOT ${BUILD_SHARED_LIBRARIES}) AND (NOT ${BUILD_STATIC_LIBRARIES}))
    MESSAGE(FATAL_ERROR "Neither shared nor static build has been enabled. Aborting")
ENDIF()

# Use this to generate a private SET of libraries whose names
# won't conflict with installed versions.
SET(BUILD_USING_NAMESPACE "" CACHE STRING
	"All library names will be prefixed with 'xxx_' if this is SET to xxx.")

SET(NS)
IF (BUILD_USING_NAMESPACE)
    SET(NS "${BUILD_USING_NAMESPACE}_")
ENDIF ()

SET(MOLMODEL_LIBRARY_NAME ${NS}SimTKmolmodel CACHE STRING
    "Base name of the library being built; can't be changed here; see BUILD_USING_NAMESPACE variable."
    FORCE)

if (ASSUME_VERSIONED_SIMBODY)
    set(SIMBODY_VERTAG _${Simbody_VERSION})
endif ()

SET(CMAKE_VERBOSE_MAKEFILE OFF CACHE BOOL "Control volume of build output" )

# Caution: this variable is automatically created by the CMake
# ENABLE_TESTING() command, but we'll take it over here for
# our own purposes too.
SET(BUILD_TESTING ON CACHE BOOL
	"Control building of Molmodel test programs.")

SET(BUILD_EXAMPLES ON CACHE BOOL
	"Control building of Molmodel example programs.")
# Turning this off reduces the build time (and space) substantially,
# but you may miss the occasional odd bug. Also currently on Windows it
# is easier to debug the static tests than the DLL-liked ones.
SET(BUILD_TESTING_STATIC ON CACHE BOOL
    "If building static libraries, build static test and example programs too?")

SET(BUILD_TESTING_SHARED ON CACHE BOOL
    "If building test or example programs, include dynamically-linked ones?" )
# Create a platform name useful for some platform-specific stuff.

IF(WIN32)
    SET(NATIVE_COPY_CMD copy)
ELSEIF(APPLE)
    SET(NATIVE_COPY_CMD cp)
ELSE()
    SET(NATIVE_COPY_CMD cp)
ENDIF()

# In addition to the platform name we need to know the Application Binary
# Interface (ABI) we're building for. Currently that is either x86, meaning
# 32 bit Intel instruction SET, or x64 for 64 bit Intel instruction SET.
IF(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
    SET(PLATFORM_ABI x64)
ELSE()
    SET(PLATFORM_ABI x86)
ENDIF()

IF(WIN32)
    ADD_DEFINITIONS(-DNOMINMAX -DWIN32_LEAN_AND_MEAN -D_USE_MATH_DEFINES)

	IF(MSVC)
	    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
	ENDIF()
ENDIF()

SET(BUILD_PLATFORM "${CMAKE_HOST_SYSTEM_NAME}:${PLATFORM_ABI}" CACHE STRING
    "This is the platform and ABI we're building for. Not changeable here; use a different CMake generator instead."
    FORCE)

## When building in any of the Release modes, tell VC++ cl compiler to use
## intrinsics (i.e. sqrt instruction rather than sqrt subroutine) with
## flag /Oi.
## Caution: can't use CMAKE_CXX_COMPILER_ID MATCHES MSVC here because
## "MSVC" is a predefined CMAKE variable and will get expanded to 1 or 0
IF(MSVC)
    IF(inst_SET_to_use)
        STRING(TOUPPER ${inst_SET_to_use} CL_INST_SET)
        SET(CL_INST_SET "/arch:${CL_INST_SET}")
    ELSE()
        SET(CL_INST_SET)
    ENDIF()

    SET(BUILD_LIMIT_PARALLEL_COMPILES "" CACHE STRING
        "Set a maximum number of simultaneous compilations.")
    MARK_AS_ADVANCED(BUILD_LIMIT_PARALLEL_COMPILES)
    SET(mxcpu ${BUILD_LIMIT_PARALLEL_COMPILES}) # abbreviation

    ## C++
    SET(BUILD_CXX_FLAGS_DEBUG
        "/D _DEBUG /MDd /Od /Ob0 /RTC1 /Zi /GS- ${CL_INST_SET}")
    SET(BUILD_CXX_FLAGS_RELEASE
        "/D NDEBUG /MD  /O2 /Ob2 /Oi /GS- ${CL_INST_SET}")
    SET(BUILD_CXX_FLAGS_RELWITHDEBINFO
        "/D NDEBUG /MD  /O2 /Ob2 /Oi /Zi /GS- ${CL_INST_SET}")
    SET(BUILD_CXX_FLAGS_MINSIZEREL
        "/D NDEBUG /MD  /O1 /Ob1 /Oi /GS- ${CL_INST_SET}")

    SET(CMAKE_CXX_FLAGS_DEBUG "/MP${mxcpu} ${BUILD_CXX_FLAGS_DEBUG}"
        CACHE STRING "Can't change here -- see BUILD_CXX..." FORCE)
    SET(CMAKE_CXX_FLAGS_RELEASE "/MP${mxcpu} ${BUILD_CXX_FLAGS_RELEASE}"
        CACHE STRING "Can't change here -- see BUILD_CXX..." FORCE)
    SET(CMAKE_CXX_FLAGS_RELWITHDEBINFO "/MP${mxcpu} ${BUILD_CXX_FLAGS_RELWITHDEBINFO}"
        CACHE STRING "Can't change here -- see BUILD_CXX..." FORCE)
    SET(CMAKE_CXX_FLAGS_MINSIZEREL "/MP${mxcpu} ${BUILD_CXX_FLAGS_MINSIZEREL}"
        CACHE STRING "Can't change here -- see BUILD_CXX..." FORCE)
ENDIF()

# The source is organized into subdirectories, but we handle them all from
# this CMakeLists file rather than letting CMake visit them as SUBDIRS.
SET(MOLMODEL_SOURCE_SUBDIRS .)

ADD_DEFINITIONS(-DSimTK_MOLMODEL_LIBRARY_NAME=${MOLMODEL_LIBRARY_NAME}
                -DSimTK_MOLMODEL_MAJOR_VERSION=${MOLMODEL_MAJOR_VERSION}
                -DSimTK_MOLMODEL_MINOR_VERSION=${MOLMODEL_MINOR_VERSION}
                -DSimTK_MOLMODEL_PATCH_VERSION=${MOLMODEL_PATCH_VERSION})

ADD_DEFINITIONS(-DSimTK_MOLMODEL_SVN_REVISION="${MOLMODEL_SVN_REVISION}"
                -DSimTK_MOLMODEL_COPYRIGHT_YEARS="${MOLMODEL_COPYRIGHT_YEARS}"
                -DSimTK_MOLMODEL_AUTHORS="${MOLMODEL_AUTHORS}")

# -DSimTK_MOLMODEL_TYPE has to be defined in the target subdirectories.
# -Dmolmodel_EXPORTS defined automatically when Windows DLL build is being done.

SET(SHARED_TARGET ${MOLMODEL_LIBRARY_NAME})
SET(STATIC_TARGET ${MOLMODEL_LIBRARY_NAME}_static)

set(CMAKE_DEBUG_POSTFIX "_d")

SET(TEST_SHARED_TARGET ${SHARED_TARGET} ${Simbody_LIBRARIES})
SET(TEST_STATIC_TARGET ${STATIC_TARGET} ${Simbody_STATIC_LIBRARIES})

# These are all the places to search for header files which are
# to be part of the API.
SET(API_INCLUDE_DIRS) # start empty
FOREACH(subdir ${MOLMODEL_SOURCE_SUBDIRS})
    # append
    SET(API_INCLUDE_DIRS ${API_INCLUDE_DIRS}
                         ${subdir}/include
                         ${subdir}/include/molmodel
                         ${subdir}/include/molmodel/internal)
ENDFOREACH(subdir)

# We'll need both *relative* path names, starting with their API_INCLUDE_DIRS,
# and absolute pathnames.
SET(API_REL_INCLUDE_FILES)   # start these out empty
SET(API_ABS_INCLUDE_FILES)

FOREACH(dir ${API_INCLUDE_DIRS})
    FILE(GLOB fullpaths ${dir}/*.h)	# returns full pathnames
    SET(API_ABS_INCLUDE_FILES ${API_ABS_INCLUDE_FILES} ${fullpaths})

    FOREACH(pathname ${fullpaths})
        GET_FILENAME_COMPONENT(filename ${pathname} NAME)
        SET(API_REL_INCLUDE_FILES ${API_REL_INCLUDE_FILES} ${dir}/${filename})
    ENDFOREACH(pathname)
ENDFOREACH(dir)

# collect up source files
SET(SOURCE_FILES) # empty
SET(SOURCE_INCLUDE_FILES)

FOREACH(subdir ${MOLMODEL_SOURCE_SUBDIRS})
    FILE(GLOB src_files ${subdir}/src/*.cpp ${subdir}/src/*.c
                        ${subdir}/src/*/*.cpp ${subdir}/src/*/*.c)
    FILE(GLOB incl_files ${subdir}/src/*.h ${subdir}/src/*/*.h)


    SET(SOURCE_FILES         ${SOURCE_FILES}         ${src_files})   #append
    SET(SOURCE_INCLUDE_FILES ${SOURCE_INCLUDE_FILES} ${incl_files})

    ## Make sure we find these locally before looking in
    ## SimTK/include if Molmodel was previously installed there.
    INCLUDE_DIRECTORIES(BEFORE ${PROJECT_SOURCE_DIR}/${subdir}/include)
ENDFOREACH(subdir)

INCLUDE_DIRECTORIES(BEFORE ${PROJECT_SOURCE_DIR}/src)

if (NOT ${GEMMI_DIR} STREQUAL "")
    include_directories("${GEMMI_DIR}/include")
endif ()

#
# Allow automated build and dashboard.
#

INCLUDE (Dart)
if (BUILD_TESTING)
    ENABLE_TESTING()
endif ()

# all the various variables have been SET above.

# Fixup Simbody library names in case we are building against versioned Simbody libraries
if (ASSUME_VERSIONED_SIMBODY)
    foreach(SL ${Simbody_LIBRARIES})
        list(APPEND SIMBODY_FIXED_LIBS ${SL}${SIMBODY_VERTAG})
        list(APPEND SIMBODY_FIXED_STATIC_LIBS ${SL}${SIMBODY_VERTAG}_static)
    endforeach()
else ()
    set(SIMBODY_FIXED_LIBS ${Simbody_LIBRARIES})
    set(SIMBODY_FIXED_STATIC_LIBS ${Simbody_STATIC_LIBRARIES})
endif ()

# Set installation directories
if (UNIX)
    include(GNUInstallDirs)
elseif (WIN32)
    set(CMAKE_INSTALL_LIBDIR "lib")
    set(CMAKE_INSTALL_INCLUDEDIR "include")
    set(CMAKE_INSTALL_BINDIR "bin")
endif ()

if (BUILD_SHARED_LIBRARIES)
    add_library(
        ${SHARED_TARGET} SHARED
        ${SOURCE_FILES}
        ${SOURCE_INCLUDE_FILES}
        ${API_ABS_INCLUDE_FILES}
    )
    set_target_properties(
        ${SHARED_TARGET}
        PROPERTIES
            PROJECT_LABEL "Library - ${SHARED_TARGET}"
            SOVERSION ${MOLMODEL_SONAME_VERSION}
    )
    target_compile_definitions(${SHARED_TARGET} PRIVATE -DSimTK_MOLMODEL_BUILDING_SHARED_LIBRARY)

    if (WIN32)
        target_link_libraries(
            ${SHARED_TARGET}
            PRIVATE ${SIMBODY_FIXED_LIBS}
            PRIVATE ${ZLIB_LIBRARIES}
            PRIVATE ws2_32
        )
    else ()
        target_link_libraries(
            ${SHARED_TARGET}
            PRIVATE ${SIMBODY_FIXED_LIBS}
            PRIVATE ${ZLIB_LIBRARIES}
        )
    endif ()

    install(
        TARGETS ${SHARED_TARGET} EXPORT MolmodelTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    )
endif ()

if (BUILD_STATIC_LIBRARIES)
    add_library(
        ${STATIC_TARGET} STATIC
        ${SOURCE_FILES}
        ${SOURCE_INCLUDE_FILES}
        ${API_ABS_INCLUDE_FILES}
    )
    set_target_properties(
        ${STATIC_TARGET}
        PROPERTIES

=== OpenMMPlugin/CMakeLists.txt ===
# Build the Molmodel OpenMM Plugin

find_package(OpenMM REQUIRED)
INCLUDE_DIRECTORIES(${OpenMM_INCLUDE_DIR})
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src)

set(CMAKE_DEBUG_POSTFIX "_d")

# The library is dependent on its local .cpp file and some of
# the Molmodel classes. We'll list everything to be safe.

if (BUILD_STATIC_LIBRARIES)
    ADD_LIBRARY(OpenMMPlugin_static STATIC
        OpenMMPlugin.cpp
        ${SOURCE_INCLUDE_FILES}
        ${API_ABS_INCLUDE_FILES})

    SET_TARGET_PROPERTIES(OpenMMPlugin_static
                          PROPERTIES
                          OUTPUT_NAME OpenMMPlugin
                              PROJECT_LABEL "Plugin - OpenMMPlugin (static)")

    TARGET_LINK_LIBRARIES(
        OpenMMPlugin_static
        PRIVATE ${STATIC_TARGET}                # SimTKMolmodel.dll
        PRIVATE ${SIMBODY_FIXED_STATIC_LIBS}    # We actually just need SimTKcommon but there is no easy way how to extract it from the list of all libs
        PRIVATE ${OpenMM_LIBRARIES}
    )

    install(
        TARGETS OpenMMPlugin_static EXPORT MolmodelTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/plugins
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}/plugins
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}/plugins
    )
endif ()
if (BUILD_SHARED_LIBRARIES)
    ADD_LIBRARY(OpenMMPlugin_shared SHARED
        OpenMMPlugin.cpp
        ${SOURCE_INCLUDE_FILES}
        ${API_ABS_INCLUDE_FILES})

    SET_TARGET_PROPERTIES(OpenMMPlugin_shared
                          PROPERTIES
                              OUTPUT_NAME OpenMMPlugin
                              PROJECT_LABEL "Plugin - OpenMMPlugin")

    TARGET_LINK_LIBRARIES(
        OpenMMPlugin_shared
        PRIVATE ${SHARED_TARGET}         # SimTKMolmodel.dll
        PRIVATE ${SIMBODY_FIXED_LIBS}    # We actually just need SimTKcommon but there is no easy way how to extract it from the list of all libs
        PRIVATE ${OpenMM_LIBRARIES}
    )

    install(
        TARGETS OpenMMPlugin_shared EXPORT MolmodelTargets
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}/plugins
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}/plugins
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}/plugins
    )
endif ()

=== examples/CMakeLists.txt ===
# Generate and install examples.
#
# This is boilerplate code for generating a set of executables, one per
# .cpp file in an "examples" subdirectory. These are intended to
# be installed with the library but we don't handle installation
# here. Unlike the similar boilerplate code in the "tests"
# directory (but like the "tests/adhoc" boilerplate), this does
# not generate CMake ADD_TEST commands so these will never run
# automatically.
#
# For IDEs that can deal with PROJECT_LABEL properties (at least
# Visual Studio) the projects for building each of these adhoc
# executables will be labeled "Example - TheExampleName" if a file
# TheExampleName.cpp is found in this directory.
#
# We check the BUILD_TESTING_{SHARED,STATIC} variables to determine
# whether to build dynamically linked, statically linked, or both
# versions of the executable.


FILE(GLOB EXAMPLES "*.cpp")
FOREACH(EX_PROG ${EXAMPLES})
    GET_FILENAME_COMPONENT(EX_SRC  ${EX_PROG} NAME)
    GET_FILENAME_COMPONENT(EX_ROOT ${EX_PROG} NAME_WE)

    IF (BUILD_TESTING_SHARED)
        # Link with shared library
        ADD_EXECUTABLE(${EX_ROOT} ${EX_PROG})
	IF(GUI_NAME)
	    ADD_DEPENDENCIES(${EX_ROOT} ${GUI_NAME})
	ENDIF()
        SET_TARGET_PROPERTIES(${EX_ROOT}
		PROPERTIES
	      PROJECT_LABEL "Example - ${EX_ROOT}")
        TARGET_LINK_LIBRARIES(${EX_ROOT} ${TEST_SHARED_TARGET})

        INSTALL(TARGETS ${EX_ROOT} DESTINATION examples/molmodel/${CMAKE_INSTALL_BINDIR})
    ENDIF()

    IF (BUILD_STATIC_LIBRARIES AND BUILD_TESTING_STATIC)
        # Link with static library
        SET(EX_STATIC ${EX_ROOT}Static)
        ADD_EXECUTABLE(${EX_STATIC} ${EX_PROG})
	IF(GUI_NAME)
	    ADD_DEPENDENCIES(${EX_STATIC} ${GUI_NAME})
	ENDIF()
        SET_TARGET_PROPERTIES(${EX_STATIC}
		PROPERTIES
		COMPILE_FLAGS "-DSimTK_USE_STATIC_LIBRARIES"
		PROJECT_LABEL "Example - ${EX_STATIC}")
        TARGET_LINK_LIBRARIES(${EX_STATIC} ${TEST_STATIC_TARGET})
	# Don't install static examples
    ENDIF()

ENDFOREACH()

# Copy extra files associated with these examples
# to the binary directory that will be the working
# directory when the tests are run; and include them in
# the examples installation. ".obj" files contain geometry.
FILE(GLOB EXTRA_FILES "*.obj" "*.pdb" "*.vmd")
FOREACH(XTRA ${EXTRA_FILES})
    GET_FILENAME_COMPONENT(XTRA_ROOT ${XTRA} NAME)
    CONFIGURE_FILE(${XTRA} 
	           ${CMAKE_CURRENT_BINARY_DIR}/${XTRA_ROOT} COPYONLY)
    INSTALL(FILES ${XTRA} DESTINATION examples/molmodel/src)
    INSTALL(FILES ${XTRA} DESTINATION examples/molmodel/${CMAKE_INSTALL_BINDIR})
ENDFOREACH()

# install source for examples
FILE(GLOB SRC_FILES "*.cpp" "*.h")
INSTALL(FILES ${SRC_FILES} DESTINATION examples/molmodel/src)

# install .txt files except CMakeLists.txt
FILE(GLOB TXT_FILES "*.txt")
FOREACH(TXTF ${TXT_FILES})
    IF(NOT "${TXTF}" MATCHES "CMakeLists.txt")
	INSTALL(FILES ${TXTF} DESTINATION examples/molmodel/src)
    ENDIF()
ENDFOREACH()

# install the installed version of CMakeLists.txt
INSTALL(FILES InstalledCMakeLists.txt DESTINATION examples/molmodel/src
	RENAME CMakeLists.txt)

# install Makefile
INSTALL(FILES "${PROJECT_SOURCE_DIR}/examples/Makefile"
    DESTINATION examples/molmodel/src)

=== tests/CMakeLists.txt ===
# Adhoc tests are those test or demo programs which are not intended,
# or not ready, to be part of the regression suite.
ADD_SUBDIRECTORY(adhoc)

# Generate regression tests.
#
# This is boilerplate code for generating a set of executables, one per
# .cpp file in a "tests" directory. These are for test cases which 
# have been engineered to be suitable as part of the nightly regression
# test suite. Ideally, they know their correct answers and return
# a simple thumbs-up/thumbs-down result, although some regressions 
# may be present and useful just to determine if they compile and
# run to completion.
#
# For IDEs that can deal with PROJECT_LABEL properties (at least
# Visual Studio) the projects for building each of these adhoc
# executables will be labeled "Regr - TheTestName" if a file
# TheTestName.cpp is found in this directory.
#
# We check the BUILD_TESTING_{SHARED,STATIC} variables to determine
# whether to build dynamically linked, statically linked, or both
# versions of the executable.

FILE(GLOB REGR_TESTS "*.cpp")
FOREACH(TEST_PROG ${REGR_TESTS})
    GET_FILENAME_COMPONENT(TEST_ROOT ${TEST_PROG} NAME_WE)

    # Some test programs may require an argument
    SET(TEST_ARGS "")
    IF(${TEST_ROOT} MATCHES "TestLoadPdb")
        SET(TEST_ARGS "${CMAKE_SOURCE_DIR}/resources/structures/1FFK_rnafrag10.pdb")
    ELSEIF(${TEST_ROOT} MATCHES "TestBiotypeSelfCode")
        SET(TEST_ARGS "${CMAKE_SOURCE_DIR}/resources/tinker_amber99_clean.prm")
    ENDIF()

    IF (BUILD_TESTING_SHARED)
        # Link with shared library
        ADD_EXECUTABLE(${TEST_ROOT} ${TEST_PROG})
        SET_TARGET_PROPERTIES(${TEST_ROOT}
		PROPERTIES
	      PROJECT_LABEL "Test_Regr - ${TEST_ROOT}")
        TARGET_LINK_LIBRARIES(${TEST_ROOT}
                              ${TEST_SHARED_TARGET})
        ADD_TEST(${TEST_ROOT} ${EXECUTABLE_OUTPUT_PATH}/${TEST_ROOT} ${TEST_ARGS})
    ENDIF()

    IF (BUILD_STATIC_LIBRARIES AND BUILD_TESTING_STATIC)
        # Link with static library
        SET(TEST_STATIC ${TEST_ROOT}Static)
        ADD_EXECUTABLE(${TEST_STATIC} ${TEST_PROG})
        SET_TARGET_PROPERTIES(${TEST_STATIC}
		PROPERTIES
		COMPILE_FLAGS "-DSimTK_USE_STATIC_LIBRARIES"
		PROJECT_LABEL "Test_Regr - ${TEST_STATIC}")
        TARGET_LINK_LIBRARIES(${TEST_STATIC}
                              ${TEST_STATIC_TARGET})
        ADD_TEST(${TEST_STATIC} ${EXECUTABLE_OUTPUT_PATH}/${TEST_STATIC} ${TEST_ARGS})
    ENDIF()

ENDFOREACH(TEST_PROG ${REGR_TESTS})

=== tests/adhoc/CMakeLists.txt ===
# Generate adhoc tests.
#
# This is boilerplate code for generating a set of executables, one per
# .cpp file in a "tests/adhoc" subdirectory. These are for "loose" test
# cases, not suitable as regression tests but perhaps useful to the
# developer or as demos. Unlike the similar boilerplate code in the "tests"
# directory, this does not generate CMake ADD_TEST commands so these
# will never run automatically.
#
# For IDEs that can deal with PROJECT_LABEL properties (at least
# Visual Studio) the projects for building each of these adhoc
# executables will be labeled "Adhoc - TheTestName" if a file
# TheTestName.cpp is found in this directory.
#
# We check the BUILD_TESTING_{SHARED,STATIC} variables to determine
# whether to build dynamically linked, statically linked, or both
# versions of the executable.


FILE(GLOB ADHOC_TESTS "*.cpp")
FOREACH(TEST_PROG ${ADHOC_TESTS})
    GET_FILENAME_COMPONENT(TEST_ROOT ${TEST_PROG} NAME_WE)

    IF (BUILD_TESTING_SHARED)
        # Link with shared library
        ADD_EXECUTABLE(${TEST_ROOT} ${TEST_PROG})
        SET_TARGET_PROPERTIES(${TEST_ROOT}
		PROPERTIES
	      PROJECT_LABEL "Test_Adhoc - ${TEST_ROOT}")
        TARGET_LINK_LIBRARIES(${TEST_ROOT} 
					${TEST_SHARED_TARGET})
    ENDIF()

    IF (BUILD_STATIC_LIBRARIES AND BUILD_TESTING_STATIC)
        # Link with static library
        SET(TEST_STATIC ${TEST_ROOT}Static)
        ADD_EXECUTABLE(${TEST_STATIC} ${TEST_PROG})
        SET_TARGET_PROPERTIES(${TEST_STATIC}
		PROPERTIES
		COMPILE_FLAGS "-DSimTK_USE_STATIC_LIBRARIES"
		PROJECT_LABEL "Test_Adhoc - ${TEST_STATIC}")
        TARGET_LINK_LIBRARIES(${TEST_STATIC}
					${TEST_STATIC_TARGET})
    ENDIF()
    
ENDFOREACH(TEST_PROG ${ADHOC_TESTS})

# Link TestMemoryUse to psapi on Windows
IF (${CMAKE_GENERATOR} MATCHES "Visual Studio")
    IF (BUILD_TESTING_SHARED)
        TARGET_LINK_LIBRARIES(TestMemoryUse psapi)
    ENDIF()
    IF (BUILD_STATIC_LIBRARIES AND BUILD_TESTING_STATIC)
        TARGET_LINK_LIBRARIES(TestMemoryUseStatic psapi)
    ENDIF()
ENDIF (${CMAKE_GENERATOR} MATCHES "Visual Studio")

=== debian/changelog ===
molmodel (3.1.0-4.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 20:08:27 +0000

molmodel (3.1.0-4.1build1) noble; urgency=high

  * No change rebuild against libopenmm8.0t64.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 25 Mar 2024 14:49:43 +0100

molmodel (3.1.0-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062945

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 20:17:19 +0000

molmodel (3.1.0-4) unstable; urgency=medium

  * Fix FTBFS with GCC-13 (Closes: #1037780)

 -- Andrius Merkys <merkys@debian.org>  Thu, 20 Jul 2023 04:50:25 -0400

molmodel (3.1.0-3) unstable; urgency=medium

  * Adapt upstream fix to restore compatibility with gemmi (Closes: #1037472)
  * Set upstream metadata fields: Repository-Browse.
  * Update standards version to 4.6.2, no changes needed.

 -- Andrius Merkys <merkys@debian.org>  Wed, 21 Jun 2023 07:13:00 -0400

molmodel (3.1.0-2) unstable; urgency=medium

  * libopenmm-dev is a strict dependency.

 -- Andrius Merkys <merkys@debian.org>  Sun, 04 Dec 2022 03:39:42 -0500

molmodel (3.1.0-1) unstable; urgency=medium

  * New upstream release 3.1.0.
  * Adjust to soname bump.
  * Split off plugins package.
  * Install CMake and pkgconfig files.

 -- Andrius Merkys <merkys@debian.org>  Wed, 30 Nov 2022 08:17:20 -0500

molmodel (3.0.113.gd05a5b6-2) unstable; urgency=medium

  * Remove CMAKE_CXX_STANDARD setting (Closes: #1009402).
  * Bump copyright years.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.
  * Update standards version to 4.6.0, no changes needed.

 -- Andrius Merkys <merkys@debian.org>  Mon, 30 May 2022 09:08:42 -0400

=== debian/control ===
Source: molmodel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Build-Depends: dpkg-dev (>= 1.22.5),
 cmake,
 debhelper-compat (= 13),
 gemmi-dev,
 libmmdb2-dev,
 libopenmm-dev,
 libopenblas-pthread-dev,
 libsimbody-dev,
 tao-pegtl-dev,
 zlib1g-dev,
Standards-Version: 4.6.2
Section: libs
Homepage: https://simtk.org/projects/molmodel
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debichem-team/molmodel
Vcs-Git: https://salsa.debian.org/debichem-team/molmodel.git

Package: libsimtkmolmodel-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libsimtkmolmodel3.1t64 (= ${binary:Version}),
 ${misc:Depends},
Description: C++ API for creating molecular models for SimTK (development files)
 Provides C++ API for creating molecular models whose dynamics can be simulated
 using the SimTK Simbody library. Molmodel is a programmer's toolkit for
 building reduced-coordinate, yet still all-atom, models of large biopolymers
 such as proteins, RNA, and DNA. One can control the allowed mobility. By
 default, Molmodel builds torsion-coordinate models in which bond stretch and
 bend angles are rigid while bond torsion angles are mobile. But one is able
 to rigidify or free any subsets of the atoms, such as the rigid benzene ring.
 .
 Molmodel is a C++ API for biochemist-friendly molecular modeling that extends
 the Simbody API to simplify construction of high-performance articulated models
 of molecules.
 .
 This package contains development files.

Package: libsimtkmolmodel3.1t64
Provides: ${t64:Provides}
Replaces: libsimtkmolmodel3.1
Breaks: libsimtkmolmodel3.1 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: C++ API for creating molecular models for SimTK
 Provides C++ API for creating molecular models whose dynamics can be simulated
 using the SimTK Simbody library. Molmodel is a programmer's toolkit for
 building reduced-coordinate, yet still all-atom, models of large biopolymers
 such as proteins, RNA, and DNA. One can control the allowed mobility. By
 default, Molmodel builds torsion-coordinate models in which bond stretch and
 bend angles are rigid while bond torsion angles are mobile. But one is able
 to rigidify or free any subsets of the atoms, such as the rigid benzene ring.
 .
 Molmodel is a C++ API for biochemist-friendly molecular modeling that extends
 the Simbody API to simplify construction of high-performance articulated models
 of molecules.

Package: libsimtkmolmodel-plugins
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Plugins for C++ API for creating molecular models for SimTK
 Provides C++ API for creating molecular models whose dynamics can be simulated
 using the SimTK Simbody library. Molmodel is a programmer's toolkit for
 building reduced-coordinate, yet still all-atom, models of large biopolymers
 such as proteins, RNA, and DNA. One can control the allowed mobility. By
 default, Molmodel builds torsion-coordinate models in which bond stretch and
 bend angles are rigid while bond torsion angles are mobile. But one is able
 to rigidify or free any subsets of the atoms, such as the rigid benzene ring.
 .
 Molmodel is a C++ API for biochemist-friendly molecular modeling that extends
 the Simbody API to simplify construction of high-performance articulated models
 of molecules.
 .
 This package provides Molmodel plugins.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/samuelflores/molmodel/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
